#!/bin/sh

initdir=`pwd`
srcdir=$1 ; shift
dstdir=$1 ; shift

fullpath() {
  readlink -f $1
}

check() {
  echo $initdir
  echo $srcdir
  echo $dstdir
}

run() {
  if ! cd "$srcdir" ; then
    exit 1
  fi

  # Get applied patch list (patches).
  if ! hg --color=never qpush -a 2>&1 > /dev/null ; then
    exit 1
  fi
  patches=`hg --color=never qapplied`
  hg --color=never qpop -a 2>&1 > /dev/null

  # Collect patches.
  if [ ! -d "$dstdir" ] ; then
    if ! mkdir -p "$dstdir" ; then
      exit 1
    fi
  fi
  rm -f "$dstdir/series"
  for p in $patches ; do
    cp "$srcdir/.hg/patches/$p" "$dstdir"
    echo $p >> "$dstdir/series"
  done

  cd "$initdir"
}

srcdir=`fullpath "$srcdir"`
dstdir=`fullpath "$dstdir"`

run
